/*
  xsetaseta@gmail.com
  Juan Galaz
  19/SEP/2017
*/

#define _DEBUG

#include <TM1638.h>
// define a module on data pin 8, clock pin 9 and strobe pin 7
TM1638 module(8, 9, 7);

#define ENTRADA1 A0
#define ENTRADA2 A1
#define ENTRADA3 A2
#define ENTRADA4 A3

#define SALIDA1 2
#define SALIDA2 3
#define SALIDA3 4

#define RESISTENCIA1 470
#define RESISTENCIA2 10000
#define RESISTENCIA3 100000

char cadena[50];
long  vxn, vcn, resistor, resistorR;
byte escala;

void setup()
{
  Serial.begin(9600);
  Serial.println("TM1638_Resistor");
  Serial.println("===============");
  pinMode(ENTRADA1, INPUT); //entrada  lectura VRx
  pinMode(ENTRADA2, INPUT);
  pinMode(ENTRADA3, INPUT);
  pinMode(ENTRADA4, INPUT);
  module.setupDisplay(1, 0); //luz
  module.setDisplayToString("SETA   r", 0, 0);
  delay(1000);
}

void loop()
{
  escala = 2;
  impedanciaH();
  pinMode(SALIDA2, OUTPUT);  digitalWrite(SALIDA2, HIGH);
  menuSet(ENTRADA3,  RESISTENCIA2);
  delay(300);
  vxn = analogRead8(ENTRADA1);  //entrada  lectura VRx
  if (vxn == 0)vxn = 1;
  if (vxn > 850) escala = 4;  //Niveles de cambio de escala
  if (vxn < 200) escala = 1;
  Serial.print("Escala="); Serial.println(escala);
  delay(300);

  switch (escala)
  {
    case 1:
      impedanciaH();
      pinMode(SALIDA1, OUTPUT);  digitalWrite(SALIDA1, HIGH);
      menuSet(ENTRADA2, RESISTENCIA1);
      break;
    case 2:
      impedanciaH();
      pinMode(SALIDA2, OUTPUT);  digitalWrite(SALIDA2, HIGH);
      menuSet(ENTRADA3, RESISTENCIA2);
      break;
    case 4:
      impedanciaH();
      pinMode(SALIDA3, OUTPUT);  digitalWrite(SALIDA3, HIGH);
      menuSet(ENTRADA4, RESISTENCIA3);
      break;
  }

  vxn = analogRead8(ENTRADA1);	//entrada  lectura VRx
  if (vxn == 0)vxn = 1;
  resistor = vxn * resistorR;    resistor /= (vcn - vxn);
#ifdef _DEBUG
  Serial.print("=> ");
  Serial.print("  vxn="); Serial.print(vxn);
  Serial.print("  vcn="); Serial.print(vcn);
#endif
  if (vxn > 1005)
  {
    sprintf(cadena, "HHHH    ");
    Serial.println(cadena);
    module.setDisplayToString(cadena, 0, 0);
  }
  else
  {
    sprintf(cadena, "r%07lu ", resistor);
    Serial.print("  R"); Serial.println(cadena);
    module.setDisplayToString(cadena, 0, 0);
    module.setDisplayDigit(cadena[4] - 48, 4, 1);
    module.setDisplayDigit(cadena[1] - 48, 1, 1);
  }
}

//
//  AltaImpedancia
void impedanciaH(void)
{
  pinMode(SALIDA1, INPUT);
  pinMode(SALIDA2, INPUT);
  pinMode(SALIDA3, INPUT);
  digitalWrite(SALIDA1, LOW);
  digitalWrite(SALIDA2, LOW);
  digitalWrite(SALIDA3, LOW);
}
//
//_______menuSet
void menuSet(byte entrada, long resistencia)
{
  vcn = analogRead8(entrada);
  if (vcn == 0)vcn = 1;
  resistorR = resistencia;
}
//
//_______lectura de 10 medidas y hace la media
int analogRead8(int entrada)
{
  int z, v;
  for (z = 0, v = 0; z < 8; z++)v += analogRead(entrada);
  v >>= 3;
  return (v);
}
